<!-- ---------------------------------------------------------
  --
  -- Author: 1q74.tistory.com
  --
  --------------------------------------------------------- -->
<!doctype html>
<html lang="ko">
<head>
<meta charset="utf-8">
<title>[1q74.tistory.com] javascript/jquery/selector/empty</title>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
</head>
<body>

	<div name="_1q74-example-root">
		<div name="_1q74-example-1">
			<h4>Which are empty tags below?</h4>
			<ul>
				<li></li>
				<li>Empty Not!</li>
				<li></li>
				<li></li>
			</ul>
				
				
			<p></p>
			<p>Empty Not!</p>
			<p></p>
			<p>Empty Not!</p>
			<p></p>
		</div>

		<div name="_1q74-example-bottom">
			<br/>
			<button name="btn-find">#1. Click Me</button>
		</div>
	</div>

	<hr/>
	<h5>[HTML Code]</h5>
	<div name="_1q74-source">
	</div>
	<h5>[//HTML Code]</h5>

<script>
const btnFind = $("[name='btn-find']");
var clickCount = 1;

btnFind.click(function() {
	const filters = [ "[style]", ":empty" ];
	const filter = filters[(clickCount % 2)];
	const emptyTags = $("[name='_1q74-example-1'] " + filter);

	emptyTags.each(function(i, el) {
		const element = $(el);

		if(!element.is("[style]")) {
			element.css("background-color", "gray");
			element.text("[emtpy]");
		} else {
			element.removeAttr("style").text("");
		}
	});

	++clickCount;
});

// ------------------------------------------------------
// 소스출력
// ------------------------------------------------------
var textSource = $("[name='_1q74-source']");
var exampleHtml = $("[name='_1q74-example-root']").html();
var specialCharLines = textSource.text(exampleHtml).html().split("\n");

textSource.html(specialCharLines.join("<br/>").replaceAll("\t", "&nbsp;&nbsp;"));
</script>
<style>
[name|="_1q74-example"] button
,[name="_1q74-source"] button {
	background: lightgray;
	border: 5px outset;
	min-height: 30px;
}

[name|="_1q74-example"] button:active
,[name="_1q74-source"] button:active {
	border: 2px inset;
	min-height: 30px;
}
</style>

</body>
</html>
